using System;
using System.Collections.Generic;
using Seasar.Extension.ADO;

namespace Seasar.Extension.ADO.Impl
{
    class SqlLogRegistryImpl : ISqlLogRegistry
    {
        private const int DEFAULT_LIMIT_SIZE = 3;

        private int limitSize;

        [ThreadStatic]
        private LinkedList<ISqlLog> threadList = new LinkedList<ISqlLog>();

        public SqlLogRegistryImpl()
            : this(DEFAULT_LIMIT_SIZE)
        {
        }

        public SqlLogRegistryImpl(int limitSize)
        {
            this.limitSize = limitSize;
        }

        public int getLimitSize()
        {
            return limitSize;
        }

        public int getSize()
        {
            return threadList.Count;
        }

        public bool isEmpty()
        {
            return getSize() == 0;
        }

        public ISqlLog get(int index)
        {
            throw new NotSupportedException("get(int)͎Ă܂");
            //return threadList[index];  // LinkedList̓_ANZXɑΉĂȂ
        }

        public ISqlLog getLast()
        {
            return isEmpty() ? null : threadList.Last.Value;
        }

        public void add(ISqlLog sqlLog)
        {
            if (limitSize <= 0)
            {
                return;
            }
            threadList.AddLast(sqlLog);
            if (threadList.Count > limitSize)
            {
                threadList.RemoveFirst();
            }
        }

        public void clear()
        {
            threadList.Clear();
        }
    }
}
